#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/mman.h>
#include "filtere.c"

#define OFSETT 800
#define WIDTH_HOLE 300
#define WIDTH 300
#define HEIGHT  300
#define get(x,y)    ColorStart[OFSETT+(x)+WIDTH_HOLE*(y)]

  typedef unsigned char byte;

void do_it()
{
  int minx=WIDTH,miny=HEIGHT,maxx=0,maxy=0;
  int tx,ty,count;
  int dx,dy;
  byte basis;
  byte *data;
  byte *ColorStart;
  
  ColorStart=(byte *)malloc(HEIGHT*WIDTH_HOLE+800);
  fread(ColorStart,sizeof(char),HEIGHT*WIDTH_HOLE+800,stdin);
  data=(byte *)malloc(633000);
  basis=get(0,0);
  for(ty=0;ty<HEIGHT;ty++)
    for(tx=0;tx<WIDTH;tx++)
      if(get(tx,ty)!=basis)
	{
	  if (tx>maxx) maxx=tx;
	  if (tx<minx) minx=tx;
	  if (ty>maxy) maxy=ty;
	  if (ty<miny) miny=ty;
	}
  if ((maxx>=WIDTH-1)||(maxy>=HEIGHT-1))
    {
      fprintf(stderr,"The picture exceeds the frame\n");
      exit(1);
    }
  count=0;
  for(ty=miny;ty<=maxy;ty++)
    for(tx=minx;tx<=maxx;tx++)
      if(get(tx,ty)==basis)
	data[count++]=0;
      else
	data[count++]=1;

  dx=maxx-minx+1;
  dy=maxy-miny+1;
  save(stdout,(char *)data,dx,dy,RLK|MYGETPUT);
}


void main()
{
  do_it();
}
