#include <stdio.h>
#include <stdlib.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include "filtere.c"

#define ANT   1000000

void main(int argc,char **argv)
{
  int x,y,x1,y1,x2,y2,i,j;
  char *buffer,*buffer1,*buffer2;
  FILE *fd1=NULL,*fd2=NULL;
  
  if((argc<3)||(! (fd1=fopen(argv[1],"r")) )||(! (fd2=fopen(argv[2],"r")) )) 
    {
      fprintf(stderr,"Specify file1 and file2 [show] > out.file\n");
      exit(1);
    }

  buffer1=load(fd1,&x1,&y1,RLK|MYGETPUT);
  buffer2=load(fd2,&x2,&y2,RLK|MYGETPUT);

  x=x1+x2;
  if (y1!=y2) 
    {
      fprintf(stderr,"Each picture must have the same height (stupid!!)\n");
      exit(1);
    }
  
  y=y1;
  buffer=malloc(x*y);
  for(j=0;j<y;j++)
    {
      for(i=0;i<x1;i++) buffer[j*x+i]    = buffer1[x1*j+i];
      for(i=0;i<x2;i++) buffer[j*x+x1+i] = buffer2[x2*j+i];
    }
  save(stdout,buffer,x,y,RLK|MYGETPUT);
  
  if (argc>3)
    { 
      Display *display;
      GC wingc;
      Window window;
      XSetWindowAttributes attributes;
      XSizeHints size_hints;
      XEvent event;
      XImage *image;
      Visual *visual;
      int scr;
      int bwidth=2;
      int bdcolor,bgcolor;
      char *win_name;
      
      display = XOpenDisplay(NULL);
      scr = DefaultScreen(display);
      wingc = DefaultGC(display,scr);
      visual = DefaultVisual(display,scr);
      bgcolor = BlackPixel(display,scr);
      bdcolor = WhitePixel(display,scr);
      win_name=(char*)(malloc(100));
      sprintf(win_name,"%d x %d ",x,y);
      size_hints.x = 0;
      size_hints.y = 0;
      size_hints.width = x;
      size_hints.height = y;
      window = XCreateSimpleWindow(display,RootWindow(display,scr),
				   size_hints.x,size_hints.y,
				   size_hints.width,size_hints.height,
				   bwidth,bdcolor,bgcolor);
      XSetStandardProperties(display,window,win_name,NULL,
			     NULL,argv,argc,&size_hints);
      attributes.backing_store = Always;
      XChangeWindowAttributes(display,window,CWBackingStore,&attributes);
      XMapWindow(display,window);
      XSync(display,False);
      XSelectInput(display,window,ButtonPressMask);
      image=XCreateImage(display,visual,8,ZPixmap,0,(char *)buffer,x,y,8,0);
      XPutImage(display,window,wingc,image,0,0,0,0,x,y);
      XNextEvent(display,&event);
      XCloseDisplay(display);
    }
}

  



