#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include "filtere.c"

#define ANT   1000000

void main(int argc,char **argv)
{
  int x,y,i=0,j;
  int a,f1,f2,a1,a2,offsetx,offsety;
  char *buffer,*buffer3;
  double factor;

  if(argc<3) fprintf(stderr,"argv[0] x y [show] < file.in > file.out \n");
  a1=atoi(argv[1]);
  a2=atoi(argv[2]);
  buffer3=(char *)malloc(ANT*sizeof(char));
  buffer=load(stdin,&x,&y,RLK|MYGETPUT);
  
  for(i=0;i<a1;i++) for(j=0;j<a2;j++) buffer3[i*a1+j]=0;

  /*
  if((double)(x)/(double)(a1)>(double)(y)/(double)(a2))
    factor=((double)(a1)/(double)(x));
  else
    factor=((double)(a2)/(double)(y));

  a=(int)factor+1;
  factor/=(double)a;
  */
  factor=1.0;
  a=1;
  
  offsety = abs((a2-(int)((double)(y*a)*factor))/2);
  offsetx = abs((a1-(int)((double)(x*a)*factor))/2);

  for(j=0;j<y;j++)
    for(f1=0;f1<a;f1++)
      for(i=0;i<x;i++)
	for(f2=0;f2<a;f2++)
	  if(buffer[i+j*x])
	    buffer3[ ( (int) ((double)(j*a+f1)*factor) +offsety)*a1+
		    (int) ((double)(i*a+f2)*factor) +offsetx]=1;
  

  save(stdout,buffer3,a1,a2,RLK|MYGETPUT);
  
  if (argc>3)
    {
      Display *display;
      GC wingc;
      Window window;
      XSetWindowAttributes attributes;
      XSizeHints size_hints;
      XEvent event;
      XImage *image;
      Visual *visual;
      int scr;
      int bwidth=2;
      int bdcolor,bgcolor;
      char *win_name;
  
      display = XOpenDisplay(NULL);
      scr = DefaultScreen(display);
      wingc = DefaultGC(display,scr);
      visual = DefaultVisual(display,scr);
      bgcolor = BlackPixel(display,scr);
      bdcolor = WhitePixel(display,scr);
      win_name=(char*)(malloc(100));
      sprintf(win_name,"%d x %d , buffer",a1,a2);
      size_hints.x = 0;
      size_hints.y = 0;
      size_hints.width = a1;
      size_hints.height = a2;
      window = XCreateSimpleWindow(display,RootWindow(display,scr),
				   size_hints.x,size_hints.y,
				   size_hints.width,size_hints.height,
				   bwidth,bdcolor,bgcolor);
      XSetStandardProperties(display,window,win_name,NULL,
			     NULL,argv,argc,&size_hints);
      attributes.backing_store = Always;
      XChangeWindowAttributes(display,window,CWBackingStore,&attributes);
      XMapWindow(display,window);
      XSync(display,False);
      XSelectInput(display,window,ButtonPressMask);
      image=XCreateImage(display,visual,8,
			 ZPixmap,0,(char *)buffer3,
			 a1,a2,8,0);
      XPutImage(display,window,wingc,image,0,0,0,0,a1,a2);
      XNextEvent(display,&event);
      XCloseDisplay(display);
    }
}

  



