/* What cursor to show in every state and window */
static struct Risk_Cursors all_cursors[]=
{
/*Function   	,risk		,cards		,info		,scrollwin */
{ FIRST_STATE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ INIT_PLAYER	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ INIT_MAPWIN	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ INIT_CARDWIN	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ INIT_INFOWIN 	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ PRESS_BUTTON	,NUMB_CURSORS	,NUMB_CURSORS	,RISK_PRESS	,NUMB_CURSORS	},
{ GET_NAME	,NUMB_CURSORS	,NUMB_CURSORS	,RISK_WRITE	,NUMB_CURSORS	},
{ CHECK_NAME	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ WAIT_FOR_ALL_0,NUMB_CURSORS	,NUMB_CURSORS	,RISK_WAIT	,NUMB_CURSORS	},
{ INIT_PL_STAT 	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ SET_UP_CARDWIN,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ SET_UP_MAPWIN	,NUMB_CURSORS	,RISK_CURSOR	,NUMB_CURSORS	,NUMB_CURSORS	},
{ INIT_ARMIES	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ I_A_WHERE	,RISK_PLACE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ I_A_STRENG	,RISK_WRITE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ I_A_NUMBER	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ I_A_PLACE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ WAIT_FOR_ALL_1,RISK_WAIT	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ WAIT_FOR_TURN	,RISK_WAIT	,NUMB_CURSORS	,RISK_WAIT	,NUMB_CURSORS	},
{ START_TURN	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ P_A_WHERE	,RISK_PLACE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ P_A_STRENG	,RISK_WRITE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ P_A_NUMBER	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ P_A_PLACE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ FIND_A_COUNTRY,RISK_CURSOR	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ ATTACK_LAND	,RISK_ATTACK	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ A_STRENG	,RISK_WRITE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ A_NUMBER	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ A_PLACE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ FREE_MOVE_INIT,RISK_MOVE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ FREE_MOVE_FROM,RISK_MOVE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ FREE_MOVE_TO	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ F_M_STRENG	,RISK_WRITE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ F_M_NUMBER	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ F_M_PLACE	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ END_TURN	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ END_GAME	,RISK_WAIT	,RISK_WAIT	,RISK_WAIT	,RISK_DIE	},
{ CLOSE_GAME	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	},
{ DUMMY_FUNC	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS	,NUMB_CURSORS   }	
};
