#include "xrisk.h"
#include "xriskex.h"
#include "risklibex.h"
#include "xrisklibex.h"

/* We lost connection to a player */
int xrisk_errorhandler(display)
     Display *display;
{
  int t;
  static int errnum = 0;
  playerp player=NULL;

  if (++errnum > 100) risk_exit("To many errors occured (%d)",errnum,LAST_ARG);
  Do_each_player(t) if (players[t]->xcon->disp == display) player=players[t];
  if (!player) risk_exit("Mistake in xrisk_errorhandler",LAST_ARG);

  if ( player->state->state <= INIT_PL_STAT ) risk_exit
    ("Player(%s) killed a window. Exiting to avoid trouble.\n",player->client);
  fprintf(stderr,"Probably broken pipe server %s, forgets it and continues\n",
	  DisplayString(display));
  
  if (player->state->state < END_GAME)
    {
      player->xcon = NULL;
      num_players--;
      new_state(player,END_GAME);
    }
  players[player->indexs] = NULL;
  (who_where[player->state->state]) ^= (1<<player->indexs);
  write_msg_all_arg
    ("#077_%s probably destroy a window in anger, but we fooled him"
     ,player->name,LAST_ARG);
  check_mission((playerp)NULL);
  xrisk_mainloop();
  return(0);
}

void init_errorhandlers()
{
  /* Notice than xrisk_mainloop never returns */
  /* Errors almost allways occures as a result of someone killing his window */
  XSetIOErrorHandler(xrisk_errorhandler);
}
