#include "xrisk.h"
#include "risklibex.h"

int load_risk_font(disp, pxfs, name)
     Display      *disp;
     XFontStruct **pxfs;
     char         *name;
{
  if ( ! ((*pxfs) = XLoadQueryFont(disp,name))
      || (*pxfs)->max_bounds.width != 6
      || (*pxfs)->ascent + (*pxfs)->descent != 13)
    return(0);
  return(1);
}

int assign_font(player)
     playerp player;
{
  XFontStruct *xfs;
  xconp xinfo;
  XGCValues values;
  
  xinfo = player->xcon;
  if (!load_risk_font(xinfo->disp,&xfs,"fixed")
      && !load_risk_font(xinfo->disp,&xfs,"6x13"))
    risk_exit("Unable to find 6x13 font on client %s\n",
	      player->client);
  values.font = xfs->fid;
  XChangeGC(xinfo->disp,xinfo->gc,GCFont,&values);
  return(1);
}
