#include "functionsex.h"
#include "functionsdef.h"

static struct All_Actions all_actions[]=
{
/* state	,scroll_win			,init_func	,init_next_1	,init_next_2	,func		,func_next_1	,funct_next_2	,
mB1-func	,mB1-next_1	,mB1-next_2	,mB2-func	,mB2-next_1	,mb2_next_2	,mB3-func	,mB3-next_1	,mB3-next_2	,
kB-func		,kB-next_1	,kB-next_2	,spec_func	,spec-next_1	,spec-next_2	,exit_func	,exit_next_1	,exit_next_2	,*/
    
 {FIRST_STATE	,DUMMY_FUNC			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{next		,{INIT_PLAYER	,DUMMY_FUNC	}}, 
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {INIT_PLAYER	,DUMMY_FUNC			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{init_player	,{INIT_MAPWIN	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {INIT_MAPWIN   ,DUMMY_FUNC			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{init_mapwin	,{INIT_CARDWIN	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {INIT_CARDWIN  ,DUMMY_FUNC			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{init_cardwin	,{INIT_INFOWIN	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {INIT_INFOWIN  ,DUMMY_FUNC			,{init_infowin	,{DUMMY_FUNC	,DUMMY_FUNC   }},{set_up_infowin,{PRESS_BUTTON	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {PRESS_BUTTON  ,DUMMY_FUNC			,{get_col_init	,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{get_col_equal	,{GET_NAME	,DUMMY_FUNC   }},{get_col_exit	,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {GET_NAME      ,DUMMY_FUNC			,{get_name_init	,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{get_string	,{CHECK_NAME	,DUMMY_FUNC   }},{get_name_exit	,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {CHECK_NAME	,DUMMY_FUNC			,{check_name	,{GET_NAME	,DUMMY_FUNC   }},{export_name	,{WAIT_FOR_ALL_0,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {WAIT_FOR_ALL_0,DUMMY_FUNC			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{mission_fix	,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {INIT_PL_STAT  ,DUMMY_FUNC			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{init_pl_stat	,{SET_UP_CARDWIN,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {SET_UP_CARDWIN,DUMMY_FUNC			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{set_up_cardwin,{SET_UP_MAPWIN	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {SET_UP_MAPWIN ,DUMMY_FUNC			,{fix_colors	,{DUMMY_FUNC	,DUMMY_FUNC   }},{set_up_mapwin	,{INIT_ARMIES	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {INIT_ARMIES   ,DUMMY_FUNC			,{i_init_armies	,{I_A_WHERE	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {I_A_WHERE	,DUMMY_FUNC			,{p_a_where_init,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{i_a_where	,{I_A_STRENG	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {I_A_STRENG	,DUMMY_FUNC			,{p_a_get_num_i	,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{number_m1	,{I_A_PLACE	,DUMMY_FUNC   }},{number_m2	,{I_A_PLACE	,DUMMY_FUNC   }},{number_m3	,{I_A_PLACE	,I_A_WHERE	}}},
 {get_string	,{I_A_NUMBER	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{clear_string	,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {I_A_NUMBER	,DUMMY_FUNC			,{p_a_number	,{I_A_PLACE	,I_A_STRENG   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {I_A_PLACE	,DUMMY_FUNC			,{p_a_place	,{I_A_WHERE	,WAIT_FOR_ALL_1}},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {WAIT_FOR_ALL_1,DUMMY_FUNC			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {WAIT_FOR_TURN ,DUMMY_FUNC			,{wait_msg	,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {START_TURN	,DUMMY_FUNC			,{init_turn	,{P_A_WHERE	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {P_A_WHERE	,DUMMY_FUNC			,{p_a_where_init,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{p_a_where	,{P_A_STRENG	,P_A_PLACE    }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {P_A_STRENG	,DUMMY_FUNC			,{p_a_get_num_i	,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{number_m1	,{P_A_PLACE	,DUMMY_FUNC   }},{number_m2	,{P_A_PLACE	,DUMMY_FUNC   }},{number_m3	,{P_A_PLACE	,P_A_WHERE	}}},
 {get_string	,{P_A_NUMBER	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{clear_string	,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {P_A_NUMBER	,DUMMY_FUNC			,{p_a_number	,{P_A_PLACE	,P_A_STRENG   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {P_A_PLACE	,DUMMY_FUNC			,{p_a_place	,{P_A_WHERE	,FIND_A_COUNTRY}},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{disable_ca_ch	,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {FIND_A_COUNTRY	,FREE_MOVE_INIT		,{f_a_where_init,{P_A_WHERE	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{f_a_where	,{ATTACK_LAND	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {ATTACK_LAND   ,FREE_MOVE_INIT			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{attack_country,{FIND_A_COUNTRY,A_STRENG     }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{next		,{FIND_A_COUNTRY,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {A_STRENG	,FREE_MOVE_INIT			,{p_a_get_num_i	,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{number_m1	,{A_PLACE	,DUMMY_FUNC   }},{number_m2	,{A_PLACE	,DUMMY_FUNC   }},{number_m3	,{A_PLACE	,FIND_A_COUNTRY	}}},
 {get_string	,{A_NUMBER	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{clear_string	,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {A_NUMBER	,FREE_MOVE_INIT			,{p_a_number	,{A_PLACE	,A_STRENG     }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {A_PLACE	,FREE_MOVE_INIT			,{p_a_place	,{FIND_A_COUNTRY,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {FREE_MOVE_INIT,DUMMY_FUNC	                ,{free_move_init,{FREE_MOVE_FROM,END_TURN     }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {FREE_MOVE_FROM,END_TURN			,{free_move_left,{END_TURN	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{f_m_where	,{FREE_MOVE_TO	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {FREE_MOVE_TO  ,END_TURN			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{free_move_to	,{F_M_STRENG	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{next		,{FREE_MOVE_FROM,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {F_M_STRENG	,END_TURN			,{p_a_get_num_i	,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{number_m1	,{F_M_PLACE	,DUMMY_FUNC   }},{number_m2	,{F_M_PLACE	,DUMMY_FUNC   }},{number_m3	,{F_M_PLACE	,FREE_MOVE_FROM	}}},
 {get_string	,{F_M_NUMBER	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{clear_string	,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {F_M_NUMBER	,END_TURN			,{p_a_number	,{F_M_PLACE	,F_M_STRENG   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {F_M_PLACE	,END_TURN			,{p_a_place	,{FREE_MOVE_FROM,END_TURN     }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {END_TURN	,DUMMY_FUNC			,{end_turn	,{WAIT_FOR_TURN	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {END_GAME	,CLOSE_GAME			,{end_game	,{DUMMY_FUNC	,DUMMY_FUNC   }},{update_pointer,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {CLOSE_GAME	,DUMMY_FUNC			,{close_game	,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},

 {DUMMY_FUNC    ,DUMMY_FUNC			,{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}},
 {{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC	}}},
 {NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC     }}}
};

static struct Actions_Other_Win actions_other_win[]=
{
/*Window	,mB1-func	,mB1-next_1	,mB1-next_2	,mB2-func	,mB2-next_1	,mB2-next_2	,mB3-func	,mB3-next_1	,mB3-next_2	,*/
{SCROLL_WIN	,{{scroll_func	,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC    }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC    }}}},
{CARD_WIN	,{{card_handler	,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC    }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC    }}}},
{INFO_WIN	,{{NULL		,{DUMMY_FUNC	,DUMMY_FUNC   }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC    }},{NULL		,{DUMMY_FUNC	,DUMMY_FUNC    }}}},
};
