/* States the game are running through */

#define FIRST_STATE		 0  /* Nothing done                          */
#define INIT_PLAYER      	 1  /* Some initializition of player         */
#define INIT_MAPWIN	  	 2  /* Initialize the map-window             */
#define INIT_CARDWIN      	 3  /* Initialize the card-window            */
#define INIT_INFOWIN    	 4  /* Initialize the info-window            */
#define PRESS_BUTTON      	 5  /* Let player choose color               */
#define GET_NAME          	 6  /* Let player choose name                */
#define CHECK_NAME          	 7  /* Check given name and export it        */
#define WAIT_FOR_ALL_0      	 8  /* Wait until everybode is here          */
#define INIT_PL_STAT	   	 9  /* Initialize statistics                 */
#define SET_UP_CARDWIN    	10  /* Set up the card-window                */
#define SET_UP_MAPWIN    	11  /* Set up the map-window                 */
#define INIT_ARMIES      	12  /* Start getting first armies            */
#define I_A_WHERE		13  /* Where to place them                   */
#define I_A_STRENG		14  /* Number to place there (Write in)      */
#define I_A_NUMBER		15  /* How many did the player want          */
#define I_A_PLACE		16  /* Place those armies                    */
#define WAIT_FOR_ALL_1		17  /* Wait for all to get here              */
#define WAIT_FOR_TURN    	18  /* Wait for your turn                    */
#define START_TURN              19  /* How many armies to start with etc.    */
#define P_A_WHERE               20  /* Where to place some of those armies   */
#define P_A_STRENG              21  /* How many to place ther (Write in)     */
#define P_A_NUMBER              22  /* How many did the player want          */
#define P_A_PLACE	     	23  /* Place the armies there                */
#define FIND_A_COUNTRY    	24  /* Find country to attack from           */
#define ATTACK_LAND      	25  /* Attack that country                   */
#define A_STRENG                26  /* How many to move over to conquered .. */
#define A_NUMBER                27  /* How many did the player want to move  */
#define A_PLACE                 28  /* Move the armes                        */
#define FREE_MOVE_INIT          29  /* Initializion of free moves            */
#define FREE_MOVE_FROM   	30  /* Where to move from                    */
#define FREE_MOVE_TO     	31  /* Where to move to (target)             */
#define F_M_STRENG              32  /* Number of armies to move (Write in)   */
#define F_M_NUMBER              33  /* How many did he want to move          */
#define F_M_PLACE               34  /* Move the armies                       */
#define END_TURN                35  /* End of this turn                      */
#define END_GAME                36  /* End of this game                      */
#define CLOSE_GAME       	37  /* Close down this game                  */
#define DUMMY_FUNC       	38  /* Never used anyway                     */
#define NUM_STATES              39  /* Number of states accsessible          */

#define MENU_EXIT        0   /* Index of suecide-button                      */
#define MENU_DO_DIE      1   /* Index of do-or-die button                    */
#define MENU_ATT_FORCE   2   /* Index of attacking-forces button             */
#define MENU_MISSION     3   /* Index of mission-button                      */
#define MENU_REFRESH     4   /* Index of refresh-button                      */
#define MENU_WRITE       5   /* Index of write-message-to-all-players button */
#define MENU_NUMB        6   /* Number of menu-buttons                       */

#define SCROLL_WIN       0   /* Index of scroll-window                       */
#define CARD_WIN         1   /* Index of cards-window                        */
#define INFO_WIN         2   /* Index of information-window                  */
#define WINDOW_ACTIONS   3   /* Number of other windows with event-handling  */

#define CONTROL_WAIT_FOR_ALL_0	0 /* Used with WAIT_FOR_ALL_0                */
#define CONTROL_WAIT_FOR_ALL_1	1 /* Used with WAIT_FOR_ALL_1                */
#define CONTROL_WAIT_FOR_TURN	2 /* Used with WAIT_FOR_TURN                 */
#define CONTROL_WAIT_ALL_QUIT_1 3 /* Used at end of game                     */
#define CONTROL_WAIT_ALL_QUIT_2 4 /* Used at end of game                     */
#define CONTROL_END_GAME        5 /* Used at end of game                     */
#define CONTROL_STATES          6 /* Number of control_states                */

#define RISK_CURSOR  0      /* Index of the standard risk-cursor     */
#define RISK_ATTACK  1      /* Cursor used upon attacks              */
#define RISK_DIE     2      /* Cursor to indicate button for suecide */
#define RISK_WAIT    3      /* Wait-state                            */
#define RISK_PRESS   4      /* Press button                          */
#define RISK_WRITE   5      /* Write something                       */
#define RISK_MOVE    6      /* Move your armies                      */
#define RISK_PLACE   7      /* Place your armies                     */
#define NUMB_CURSORS 8      /* Number of cursors                     */
