#include "xrisk.h"

/* Parse command-options */
int parseopt(argc, argv)
     int    argc;
     char **argv;
{
  int          c;
  extern int   optind, opterr;
  extern char *optarg;

  opterr = 1;
  
  game_options.armies_start      = ARMIES_START;
  game_options.max_armies_start  = MAX_ARMIES_START;
  game_options.options           = DEFAULT_OPTIONS;
  if (! (game_options.language = getenv("XRISK_LANGUAGE")) )
    strcpy(game_options.language=malloc(strlen(LANGUAGE)+1),LANGUAGE); 
  
  while ((c = getopt (argc,  argv,  "l:mdh"))  !=  EOF)
    switch (c) 
      {
      case 'l':
	strcpy(game_options.language = malloc(strlen(optarg)+1),optarg);
	break;
      case 'm':
	game_options.options ^= MISSION;
	break;
      case 'd':
	game_options.options ^= TWO_ACTIVE_PLAYERS;
	break;
      case 'h':
      case '?':
	break;
      }
  return(optind);
}
